1000 REMark **********************************************************************
1010 REMark *         Example 6 shows the use of WRPTRT with timeout.            *
1020 REMark *                                                                    *
1030 REMark *         The pointer is read by WRPTRT instead of WRPTR.            *
1040 REMark *    When timeout occurs we find the position of the pointer from    *
1050 REMark *     the Status Area. If we are on a loose item we pull down a      *
1060 REMark *   secondary window, use BRPTR to read the pointer until a move or  *
1070 REMark *   key/mouse press, perform any action requested and return to the  *
1080 REMark *                        main window.                                *
1090 REMark *                                                                    *
1100 REMark * Ex6's windows are:                                                 *
1110 REMark * 1. A main window with 3 loose items and a "button" window.         *
1120 REMark * 2. Three secondary windows, one for each losse item.               *
1130 REMark **********************************************************************
1140 :
1150 REMark **********************************************************************
1160 REMark *    The following three lines instruct Turbo how to compile EX6     *
1170 REMark **********************************************************************
1180 :
1190 TURBO_objfil 'ram1_EX6_TASK':TURBO_taskn 'EX6 v2.04':TURBO_objdat 100
1200 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1210 TURBO_model '<':TURBO_struct 's'
1220 :
1230 REMark **********************************************************************
1240 REMark *         MANIFEST sets constants, not variables, for speed          *
1250 REMark **********************************************************************
1260 :
1270 MANIFEST: Move_Win=$F5:ESC=27:CF1=$E9
1280 :
1290 REMark EX6_bas v2.04
1300 REMark 18 OCT 08
1310 :
1320 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1330 :
1340 REMark **********************************************************************
1350 REMark *                  wch% is used by M_SETUP                           *
1360 REMark *           wch% is 100 if compiled and 0 otherwise                  *
1370 REMark **********************************************************************
1380 :
1390 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1400 :
1410 REMark **********************************************************************
1420 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1430 REMark * and sets wd(r), the address(es) of window definition(s)            *
1440 REMark **********************************************************************
1450 :
1460 REMark                            *******************************************
1470 wwd=M_SETUP(#wch%,wd(0),0):REMark *    To produce the working definition    *
1480 REMark                            *******************************************
1490 :
1500 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1510 :
1520 REMark **********************************************************************
1530 REMark *       We must set a primary window here if this is COMPILED.       *
1540 REMark *          (PRPOS can be thought of as PRimary POSitioned).          *
1550 REMark *      If this is not COMPILED, BOUTL has set #0 as primary, so      *
1560 REMark *         the window here must instead be "pulled down" as a         *
1570 REMark *                       secondary window.                            *
1580 REMark **********************************************************************
1590 :
1600 REMark         **************************************************************
1610 Set_Col:REMark *                   Set up colours                           *
1620 REMark         **************************************************************
1630 :
1640 REPeat lp
1650 k=WRPTRT(wwd,300,255)
1660  r=255&&get_x%(k)
1670  REMark ***************************************
1680  REMark *   r is the code extracted from k    *
1690  REMark *   255 -> a loose item               *
1700  REMark *   254 -> an event                   *
1710  REMark *   252 -> timed out                  *
1720  REMark *                                     *
1730  REMark *  get_y%(k) is the bottom word of k  *
1740  REMark *   and is the item or event number   *
1750  REMark ***************************************
1760  SELect ON r
1770   =255:REMark loose items
1780     IF do_loose%(get_y%(k)):EXIT lp
1790   =254:REMark event
1800     IF do_event%(get_y%(k)):EXIT lp
1810   =252:REMark timed out
1820     IF Do_Timeout%:EXIT lp
1830  END SELect
1840 END REPeat lp
1850 STOP
1860 :
1870 DEFine FuNction do_loose%(num%)
1880  REMark routine to do loose items
1890  LOCal k,ans%
1900  k=num%:ans%=0
1910  REMark ********************************************
1920  REMark * There are 3 loose items, numbered 0 to 2 *
1930  REMark * 0 = the move icon                        *
1940  REMark * 1 = "ESC"                                *
1950  REMark * 2 = "Action"                             *
1960  REMark ********************************************
1970  SELect ON k
1980   =1:finish:ans%=1
1990   =2:Col_Alt 0
2000   =0:mve
2010  END SELect
2020                             REMark **********************************
2030  IF NOT k=1:D_LDRW num%,wwd:REMark * Resets the item to "available" *
2040                             REMark **********************************
2050  RETurn ans%
2060 END DEFine
2070 :
2080 DEFine FuNction Do_Timeout%
2090                                        REMark *******************************
2100                                        REMark *    If on a loose item       *
2110  LOCal stadr,x:                        REMark *       -> Do_Indic%          *
2120  stadr=PEEK_L(wwd):                    REMark *     ->status area           *
2130  IF PEEK_W(stadr+12)<>-1:RETurn 0:     REMark *   Not in main window        *
2140  x=PEEK_W(stadr+$30):                  REMark * x = loose item number (?)   *
2150  IF x<0:RETurn 0:ELSE RETurn Do_Indic%:REMark * If  x < 0 not a loose item  *
2160                                       :REMark *******************************
2170 END DEFine
2180 :
2190 DEFine PROCedure Set_Col:            REMark *********************************
2200  DIM colv%(5):                       REMark * The values of 6 colours are   *
2210  colv%(0)=L_RED%:colv%(1)=D_RED%:    REMark * stored in colv%. The initial  *
2220  colv%(2)=L_GREEN%:colv%(3)=D_GREEN%:REMark * value of the colour pointer   *
2230  colv%(4)=MUSTARD%:colv%(5)=GREY%:   REMark *    col_no% is 1 - D_RED%      *
2240  col_no%=1:                          REMark *********************************
2250 END DEFine
2260 :
2270 DEFine PROCedure do_sec:          REMark *************************************
2280  LOCal pos1,pos2,y:               REMark *   -Indicator Window Program-      *
2290  pos1=BRPTR(48,0,wwd1):           REMark *  pos1 = current pointer position  *
2300  pos2=BRPTR(11,pos1,wwd1):acty=-1:REMark * wait till move or key/mouse press *
2310  IF pos1<>pos2:RETurn :           REMark *    If move just close window      *
2320  y=PEEK(PEEK_L(wwd1)+$12):        REMark *         y = key pressed           *
2330   SELect ON y
2340             :                     REMark * If hit, do, A/a, Sleep, Move or   *
2350             :                     REMark *           ESC do it.              *
2360   =1,2:acty=x:                    REMark *    x is the loose item number     *
2370   =ESC:acty=1:                    REMark *    acty is set . . .              *
2380   =Move_Win:acty=0:               REMark *    . . . to the . . .             *
2390   =CODE("A"),CODE('a'):acty=2:    REMark *    . . . loose item number        *
2400   =CF1:acty=do_event%(32)-1:      REMark *     Sleep required here!          *
2410  END SELect :                     REMark *************************************
2420 END DEFine
2430 :
2440 DEFine PROCedure finish
2450  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
2460  BRECHP:STOP
2470 END DEFine
2480 :
2490 DEFine PROCedure mve:             REMark ************************************
2500  BCHWIN wwd:                      REMark *          Move the window         *
2510 END DEFine :                      REMark ************************************
2520 :
2530 DEFine FuNction Do_Indic%
2540 :
2550                                  REMark *************************************
2560  wwd1=M_SETUP(#0,wd(x+1),-1):    REMark *   Set the working definition.     *
2570  chid1=M_PULLD(wwd1,-1):         REMark *     Make the window appear.       *
2580  do_sec:                         REMark *  Process this window until . .    *
2590  BUNST wwd1:                     REMark *    . .  it disappears . .         *
2600  CLOS chid1:                     REMark * . . and its channel is closed.    *
2610  BRCHP wwd1:                     REMark *  Returns the space for working    *
2620  IF acty<0:RETurn 0:             REMark *         definition.               *
2630  IF acty=0:D_LDRW 128*65536,wwd
2640  RETurn do_loose%(acty):         REMark *    The action set by do_sec       *
2650                                  REMark *************************************
2660 END DEFine
2670 :
2680 DEFine PROCedure Col_Alt(o%):      REMark ***********************************
2690  IF o%=0:col_no%=(col_no%+1) MOD 6:REMark * Set the next colour number . .  *
2700  POKE_W wwd+$2E,colv%(col_no%):    REMark * . . to the working definition   *
2710  BWRSET wwd:                       REMark *       Redraw the window         *
2720 END DEFine :                       REMark ***********************************
2730 :
2740 DEFine FuNction do_event%(k%):               REMark *************************
2750  IF 32&&k%:Do_Sleep wwd,chid,wch%:Col_Alt 1: REMark *    No loose item      *
2760  RETurn 0:                                   REMark *************************
2770 END DEFine
2780 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We also need to be sure that the window *
17030 REMark * definition will be included at lines 19600.          *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17080 REMark * 2. The window definition is added by the routine Mw  *
17090 REMark * 3. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites and producing an app menu. *
17110 REMark *                                                      *
17120 REMark * Once Ex6_bas is loaded, pressing Mr, Mw, St, Charge  *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_EX6_WDA"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure st
18100  Remov "Sprite Menu"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex6_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
